1. Packages
  2. Packages
  3. Pulumi Cloud (Pulumi Service provider)
  4. API Docs
  5. api
  6. api/stacks
  7. Config

This provider is currently in preview.

Viewing docs for Pulumi Cloud v1.1.0
published on Thursday, May 21, 2026 by Pulumi
pulumiservice logo

This provider is currently in preview.

Viewing docs for Pulumi Cloud v1.1.0
published on Thursday, May 21, 2026 by Pulumi

    Updates the service-managed configuration for a stack. The request body may include the ESC environment reference, secrets provider type, encrypted key, and encryption salt. If stack configuration is returned by the API, it is used in place of the local stack config file (e.g. Pulumi.[stack].yaml). Returns the updated configuration object. Returns 400 if the environment reference is invalid or not found.

    Create Config Resource

    Resources are created with functions called constructors. To learn more about declaring and configuring resources, see Resources.

    Constructor syntax

    new Config(name: string, args: ConfigArgs, opts?: CustomResourceOptions);
    @overload
    def Config(resource_name: str,
               args: ConfigArgs,
               opts: Optional[ResourceOptions] = None)
    
    @overload
    def Config(resource_name: str,
               opts: Optional[ResourceOptions] = None,
               environment: Optional[str] = None,
               org_name: Optional[str] = None,
               project_name: Optional[str] = None,
               stack_name: Optional[str] = None,
               encrypted_key: Optional[str] = None,
               encryption_salt: Optional[str] = None,
               secrets_provider: Optional[str] = None)
    func NewConfig(ctx *Context, name string, args ConfigArgs, opts ...ResourceOption) (*Config, error)
    public Config(string name, ConfigArgs args, CustomResourceOptions? opts = null)
    public Config(String name, ConfigArgs args)
    public Config(String name, ConfigArgs args, CustomResourceOptions options)
    
    type: pulumiservice:api/stacks:Config
    properties: # The arguments to resource properties.
    options: # Bag of options to control resource's behavior.
    
    
    resource "pulumiservice_api_stacks_config" "name" {
        # resource properties
    }

    Parameters

    name string
    The unique name of the resource.
    args ConfigArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    resource_name str
    The unique name of the resource.
    args ConfigArgs
    The arguments to resource properties.
    opts ResourceOptions
    Bag of options to control resource's behavior.
    ctx Context
    Context object for the current deployment.
    name string
    The unique name of the resource.
    args ConfigArgs
    The arguments to resource properties.
    opts ResourceOption
    Bag of options to control resource's behavior.
    name string
    The unique name of the resource.
    args ConfigArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    name String
    The unique name of the resource.
    args ConfigArgs
    The arguments to resource properties.
    options CustomResourceOptions
    Bag of options to control resource's behavior.

    Constructor example

    The following reference example uses placeholder values for all input properties.

    var configResource = new PulumiService.Api.Stacks.Config("configResource", new()
    {
        Environment = "string",
        OrgName = "string",
        ProjectName = "string",
        StackName = "string",
        EncryptedKey = "string",
        EncryptionSalt = "string",
        SecretsProvider = "string",
    });
    
    example, err := stacks.NewConfig(ctx, "configResource", &stacks.ConfigArgs{
    	Environment:     pulumi.String("string"),
    	OrgName:         pulumi.String("string"),
    	ProjectName:     pulumi.String("string"),
    	StackName:       pulumi.String("string"),
    	EncryptedKey:    pulumi.String("string"),
    	EncryptionSalt:  pulumi.String("string"),
    	SecretsProvider: pulumi.String("string"),
    })
    
    resource "pulumiservice_api_stacks_config" "configResource" {
      environment      = "string"
      org_name         = "string"
      project_name     = "string"
      stack_name       = "string"
      encrypted_key    = "string"
      encryption_salt  = "string"
      secrets_provider = "string"
    }
    
    var configResource = new Config("configResource", ConfigArgs.builder()
        .environment("string")
        .orgName("string")
        .projectName("string")
        .stackName("string")
        .encryptedKey("string")
        .encryptionSalt("string")
        .secretsProvider("string")
        .build());
    
    config_resource = pulumiservice.api.stacks.Config("configResource",
        environment="string",
        org_name="string",
        project_name="string",
        stack_name="string",
        encrypted_key="string",
        encryption_salt="string",
        secrets_provider="string")
    
    const configResource = new pulumiservice.api.stacks.Config("configResource", {
        environment: "string",
        orgName: "string",
        projectName: "string",
        stackName: "string",
        encryptedKey: "string",
        encryptionSalt: "string",
        secretsProvider: "string",
    });
    
    type: pulumiservice:api/stacks:Config
    properties:
        encryptedKey: string
        encryptionSalt: string
        environment: string
        orgName: string
        projectName: string
        secretsProvider: string
        stackName: string
    

    Config Resource Properties

    To learn more about resource properties and how to use them, see Inputs and Outputs in the Architecture and Concepts docs.

    Inputs

    In Python, inputs that are objects can be passed either as argument classes or as dictionary literals.

    The Config resource accepts the following input properties:

    Environment string
    Reference to ESC environment to use as stack configuration.
    OrgName string
    The organization name
    ProjectName string
    The project name
    StackName string
    The stack name
    EncryptedKey string
    The KMS-encrypted ciphertext for the data key used for secrets encryption. Only used for cloud-based secrets providers.
    EncryptionSalt string
    The stack's base64-encoded encryption salt. Only used for passphrase-based secrets providers.
    SecretsProvider string
    The stack's secrets provider.
    Environment string
    Reference to ESC environment to use as stack configuration.
    OrgName string
    The organization name
    ProjectName string
    The project name
    StackName string
    The stack name
    EncryptedKey string
    The KMS-encrypted ciphertext for the data key used for secrets encryption. Only used for cloud-based secrets providers.
    EncryptionSalt string
    The stack's base64-encoded encryption salt. Only used for passphrase-based secrets providers.
    SecretsProvider string
    The stack's secrets provider.
    environment string
    Reference to ESC environment to use as stack configuration.
    org_name string
    The organization name
    project_name string
    The project name
    stack_name string
    The stack name
    encrypted_key string
    The KMS-encrypted ciphertext for the data key used for secrets encryption. Only used for cloud-based secrets providers.
    encryption_salt string
    The stack's base64-encoded encryption salt. Only used for passphrase-based secrets providers.
    secrets_provider string
    The stack's secrets provider.
    environment String
    Reference to ESC environment to use as stack configuration.
    orgName String
    The organization name
    projectName String
    The project name
    stackName String
    The stack name
    encryptedKey String
    The KMS-encrypted ciphertext for the data key used for secrets encryption. Only used for cloud-based secrets providers.
    encryptionSalt String
    The stack's base64-encoded encryption salt. Only used for passphrase-based secrets providers.
    secretsProvider String
    The stack's secrets provider.
    environment string
    Reference to ESC environment to use as stack configuration.
    orgName string
    The organization name
    projectName string
    The project name
    stackName string
    The stack name
    encryptedKey string
    The KMS-encrypted ciphertext for the data key used for secrets encryption. Only used for cloud-based secrets providers.
    encryptionSalt string
    The stack's base64-encoded encryption salt. Only used for passphrase-based secrets providers.
    secretsProvider string
    The stack's secrets provider.
    environment str
    Reference to ESC environment to use as stack configuration.
    org_name str
    The organization name
    project_name str
    The project name
    stack_name str
    The stack name
    encrypted_key str
    The KMS-encrypted ciphertext for the data key used for secrets encryption. Only used for cloud-based secrets providers.
    encryption_salt str
    The stack's base64-encoded encryption salt. Only used for passphrase-based secrets providers.
    secrets_provider str
    The stack's secrets provider.
    environment String
    Reference to ESC environment to use as stack configuration.
    orgName String
    The organization name
    projectName String
    The project name
    stackName String
    The stack name
    encryptedKey String
    The KMS-encrypted ciphertext for the data key used for secrets encryption. Only used for cloud-based secrets providers.
    encryptionSalt String
    The stack's base64-encoded encryption salt. Only used for passphrase-based secrets providers.
    secretsProvider String
    The stack's secrets provider.

    Outputs

    All input properties are implicitly available as output properties. Additionally, the Config resource produces the following output properties:

    Id string
    The provider-assigned unique ID for this managed resource.
    Id string
    The provider-assigned unique ID for this managed resource.
    id string
    The provider-assigned unique ID for this managed resource.
    id String
    The provider-assigned unique ID for this managed resource.
    id string
    The provider-assigned unique ID for this managed resource.
    id str
    The provider-assigned unique ID for this managed resource.
    id String
    The provider-assigned unique ID for this managed resource.

    Package Details

    Repository
    pulumiservice pulumi/pulumi-pulumiservice
    License
    Apache-2.0
    pulumiservice logo

    This provider is currently in preview.

    Viewing docs for Pulumi Cloud v1.1.0
    published on Thursday, May 21, 2026 by Pulumi

      Try Pulumi Cloud free.
      Your team will thank you.

      Start free trial